
;One pick
;VOL+	16k
;Vol-	24k
;SEEK+	8k
;Seek-	12k
;SRC	1k

;Hold
;VOL+	hívást felvesz	3,7k+ring
;Vol-	hívást elutasít	6k+ring
;SEEK+	8k
;Seek-	12k
;SRC	kikapcs 1k

;Doublepick
;VOL+	hívást megszakít 6k + ring
;Vol-	mute	3,7k
;SEEK+ folder up 8k+ring
;Seek- folder dwn 12k+ring
;SRC	telephone menu 1k + ring



; AN2 az a PORTA,2

    processor 16F676
    #include "P16F676.INC"
    __config 0x3F84		;0x3F84





		cblock	0x20			;start of general purpose registers
			count			;used in looping routines
			count1			;used in delay routine
			counta			;used in delay routine
			countb			;used in delay routine
			firstpressed
			hold
			adc_result
			CounterA
			CounterB
			CounterC
			pressed
			release
			fail
			repressed
			lastpressed
			decoded
			diag
			diag2
		endc



		org	0x0000
	goto	Initialise

HEX_onepick
	 ;MOVF	decoded,0
		ANDLW	b'00000111'
		ADDWF   PCL, f 
 	RETLW	0xff
	RETLW	b'11111010'	;16k
	RETLW	b'11111110'	;24k
	RETLW	b'11111100'	;8k
	RETLW	b'11111101'	;12k
	RETLW	b'11110111'	;1k
	RETLW	0xff
	RETLW	0xff

HEX_doublepick 
	 ;MOVF	decoded,0
		ANDLW	b'00000111'
		ADDWF   PCL, f 
 	RETLW	0xff
	RETLW	b'11001111'	;6k +R
	RETLW	b'11101001'	;3,7k
	RETLW	b'11011100'	;8k +R
	RETLW	b'11011101'	;12k +R
	RETLW	b'11010111'	;1k +R
	RETLW	0xff
	RETLW	0xff

HEX_hold 
	 ;MOVF	decoded,0
		ANDLW	b'00000111' 
		ADDWF   PCL, f 
 	RETLW	0xff
	RETLW	b'11001001'	;3,7k +R
	RETLW	b'11001111'	;6k +R
	RETLW	b'11111100'	;8k
	RETLW	b'11111101'	;12k
	RETLW	b'11110111'	;1k
	RETLW	0xff
	RETLW	0xff	

Initialise	clrf	count
		clrf	PORTA
		clrf	PORTC
		clrwdt
		
		

SetPorts	
		MOVLW	B'00000111'	;Disable Comparator module's
		MOVWF	CMCON
		bsf 	STATUS,		RP0	;select bank 1
		MOVLW	b'11001111'	
		movwf	TRISA		;all A input		
		movlw	b'11111111'			;make all pins output
		movwf	TRISC
		MOVLW	B'00001111'	;Set PIC options (See datasheet). (prescaler 128)
		MOVWF	OPTION_REG	;Write the OPTION register.
		MOVLW	B'00000001'
		MOVWF	ANSEL		; An2-bekapcsolva
		MOVLW	B'00000000'
		MOVWF	ADCON1		;digitalizálás frekvencia		
		CLRF	INTCON		;Disable interrupts
		bcf 	STATUS,		RP0	;select bank 0
	
		CLRF	ADCON0			;ADCON nullázása
		BCF		ADCON0,ADFM		;eredmény 1=jobbra, 0=balra (ADRESL a bank1-ben van!)
		BCF		ADCON0,VCFG		;1=Vref, 0=VDD
		BSF		ADCON0,ADON		;ADC bekapcsolva
		
		clrwdt
		clrf	hold
		movlw	.15
		movwf	fail

waitkey	
		
		clrf	repressed
		clrf	release
		clrf	hold
		clrf	PORTC
		clrf	PORTA
		movlw	.15
		movwf	fail
		
		call	Readkey1
		btfsc	pressed,0
		goto	waitkey
				
cicle
		
		clrf	release
		clrf	hold
		clrf	repressed
		call	Readkey1
		movwf	firstpressed		
cicle_x		
		call	Delay
		call	Readkey
		
		BTFSC	hold,4	;8 alkalomig tarva
		goto	nyomvatartott_gomb
		BTFSC	release,3	;8 alkalomig elengedve
		goto	duplavagyszimpla
		goto	cicle_x
duplavagyszimpla
		BTFSS	repressed,0
		goto	szimplagombnyomas
		goto	duplagombnyomas
		
nyomvatartott_gomb
		BSF		PORTA,5
		BCF		PORTA,5
		BSF		PORTA,5
		BCF		PORTA,5
		BSF		PORTA,5
		BCF		PORTA,5
		call	keycode
		call	HEX_hold
		call	porton
		call	Delayx
			
engeddmarel		
		call	Readkey1
		btfss	pressed,0
		goto	engeddmarel	
		call	portoff
		goto	waitkey

szimplagombnyomas
		
		BSF		PORTA,5
		BCF		PORTA,5
		BSF		PORTA,5
		movf	firstpressed,0
		movwf	pressed
		call	keycode
		call	HEX_onepick
		call	porton
		call	Delayx
		BCF		PORTA,5
		call	portoff
		
		goto	waitkey

duplagombnyomas
		BSF		PORTA,5
		BCF		PORTA,5
		BSF		PORTA,5
		BCF		PORTA,5
		movf	firstpressed,0
		movwf	pressed
		call	keycode
		call	HEX_doublepick
		call	porton
		call	Delayx
		call	portoff
		goto	waitkey



		
keycode		
		BTFSC	pressed,0
		retlw	.0
		BTFSC	pressed,1
		retlw	.1
		BTFSC	pressed,2
		retlw	.2
		BTFSC	pressed,3
		retlw	.3
		BTFSC	pressed,4
		retlw	.4
		BTFSC	pressed,5
		retlw	.5
		retlw	.0
	
porton	
		
		bsf 	STATUS,RP0
		movwf	TRISC
		bcf		STATUS,RP0
		movwf	PORTC
		return
portoff
		bsf 	STATUS,RP0
		movlw	0xff
		MOVWF	TRISC
		bCf 	STATUS,RP0
		return
Readkey
		call	Readkey1
		subwf	firstpressed,0
		BTFSS	STATUS,Z
		goto	masikgomb
		movf	release,1
		BTFSS	STATUS,Z
		BSF		repressed,0
		incf	hold,1
		return
masikgomb
		
		btfss	pressed,0	; elengedve
		goto	ezegyharmadikgomb
		incf	release,1
		return

ezegyharmadikgomb
		
		decfsz	fail,1		;15 hiba után semmi alapraáll
		goto	Readkey
		goto	waitkey

		
Readkey1		
		clrwdt
		
		BSF		ADCON0,CHS1
		BCF		ADCON0,CHS0		;AN2 kiválasztása
			;
		bsf     ADCON0,GO       ; start conversion
waitadc 
		
		btfsc   ADCON0,NOT_DONE ; wait until done
		goto    waitadc
		BSF		STATUS,RP0
		MOVF	ADRESL,0
		BCF		STATUS,RP0
		MOVF	ADRESH,0
		MOVWF	adc_result
		RRF		adc_result,1
		RRF		adc_result,1
		movlw	b'00111111'
		andwf	adc_result,1
		
		
		
		movlw	.12
		subwf	adc_result,0
		BTFSS	STATUS,C
		goto	gomb_1
		
		movlw	.22
		subwf	adc_result,0
		BTFSS	STATUS,C
		goto	gomb_2
		
		movlw	.32
		subwf	adc_result,0
		BTFSS	STATUS,C
		goto	gomb_3
		
		movlw	.42
		subwf	adc_result,0
		BTFSS	STATUS,C
		goto	gomb_4
		
		movlw	.52	;48
		subwf	adc_result,0
		BTFSS	STATUS,C
		goto	gomb_5
		; nincs gomb nyomva
		BSF		PORTA,4
		clrf	pressed
		BSF		pressed,0
		BCF		PORTA,4
		retlw	.1
gomb_1
		
		clrf	pressed
		BSF		pressed,1
		retlw	.2
		
gomb_2
		
		clrf	pressed
		BSF		pressed,2
		retlw	.4
		
gomb_3
		
		clrf	pressed
		BSF		pressed,3
		retlw	.8
		
gomb_4
		clrf	pressed
		BSF		pressed,4
		retlw	.16
		
gomb_5
		clrf	pressed
		BSF		pressed,5
		retlw	.32
		
				
		

		
		



EndMessage	
		
Stop	
		goto	cicle			;endless loop




	

Delay				
	
	movlw D'3'	;6 értékszer 10ms
	movwf CounterC
loop2
	movlw D'100'	;10ms
	movwf CounterB
loop1	
	movlw D'30'	;35=0,1mS
	movwf CounterA
loop
	decfsz CounterA,1
	goto loop
	decfsz CounterB,1
	goto loop1
	decfsz CounterC,1
	goto loop2
	
	
	return



Delayx		
	movlw D'25'	;25 értékszer 10ms
	movwf CounterC
loop2x
	movlw D'100'	;10ms
	movwf CounterB
loop1x	
	movlw D'37'	;35=0,1mS
	movwf CounterA
loopx
	decfsz CounterA,1
	goto loopx
	decfsz CounterB,1
	goto loop1x
	decfsz CounterC,1
	goto loop2x
	bcf		hold,0
	return

;end of LCD routines







		end